/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "unites.y" /* yacc.c:339  */

/* inclusions, dfinition */
#include <string>
#include <sstream>
#include <stdlib.h>
#include "unites.h"
#include <math.h>

using namespace std;

  int yylex();
  int yyerror(const char * msg);

  const char * unit_names[BU_LAST]={"m","kg","s","A","K","mol","cd"};

  /**
   * values returned by the lexer are instances of the class yystype
   **/
  class yystype{
  public:
    /* integer property */
    int i;
    /**
     * mutiplicators are mutiprecisions decimals.
     *
     * multip:        multiplicator to apply to the SI monome to get the unit
     * maxmultip:     an accumulator used for mixed units expressions
     * wanted_multip: a desired multiplier when a unit wish is expressed
     **/
    mpreal multip, maxmultip, wanted_multip;
    /* standard or non-standard unit index -- see unites.h */
    uniteSI unite;
    /* vector of powers (a unit is expressed as a monome of bse units)) */
    int base[BU_LAST];
    /* cstr properties */
    char * s, * v;
    /* name of a wanted unit */
    string wanted_unit;
    /* values are mutiprecisions rationals */
    mpreal val;
    /* how many significant numbers? */
    int signif;
    /* percent tolerance */
    int pcent;
    /**
     * the construcror initializes at least cstr properties to avoid
     * dangling links.
     **/
    yystype(){
      s=(char*) NULL;
      v=(char*) NULL;
    }
  };

  /**
   * display to stream operator, useful to debug yystype objects
   **/
  ostream & operator << (ostream & o, yystype data);
  ostream & operator << (ostream & o, yystype data){
    o << "YYSTYPE[" <<"i="<<data.i<<", multip="<<data.multip;
    o<<", maxmultip="<<data.maxmultip<<", wanted_multip="<<data.wanted_multip;
    o<<", unite="<<data.unite<<", base={";
    for (int i=0;i<BU_LAST;i++){
      o<<data.base[i]<<" ";
    }
    o<<"}";
    if(data.s!=NULL){ o<<", s="<<data.s;}else{o<<", s=NULL";}
    if(data.v!=NULL){o<<", v="<<data.v;}else{o<<", v=NULL";}
    o<<", wanted_unit="<<data.wanted_unit;
    o<<", val="<<data.val<<", signif="<<data.signif<<", pcent="<<data.pcent;
    o<<"] ";
    return o;
  }
  
#define YYSTYPE yystype 

 extern FILE * yyin;

/* variables globales */
#define MAXBUF 255
 char buffer[MAXBUF+1], buffer2[MAXBUF+1];
 yystype result;
 mpreal val_decimal; /* a multiprecision rational */
 int val_int, count_signif=0;
 long pos;

 /**
  * SI and non-SI units list
  * source: Handbook of Chemistry & Physics 78, CRC Press 1997, page 1-20
  * full names of the units are in French, with a Latin-1 encoding
  **/
unite_data unites[TU_LAST] ={
/*TUh*/   {"h",      "seconde",   3600.0,     { 0, 0, 1, 0, 0, 0, 0}},
/*TUmin*/ {"min",    "seconde",   60.0,       { 0, 0, 1, 0, 0, 0, 0}},
/*TUm*/   {"m",      "mtre",     1.0,        { 1, 0, 0, 0, 0, 0, 0}},
/*TUg*/   {"g",      "kilogramme",1.0e-3,     { 0, 1, 0, 0, 0, 0, 0}},
/*TUs*/   {"s",      "seconde",   1.0,        { 0, 0, 1, 0, 0, 0, 0}},
/*TUA*/   {"A",      "ampre",    1.0,        { 0, 0, 0, 1, 0, 0, 0}},
/*TUK*/   {"K",      "kelvin",    1.0,        { 0, 0, 0, 0, 1, 0, 0}},
/*TUmol*/ {"mol",    "mol",       1.0,        { 0, 0, 0, 0, 0, 1, 0}},
/*TUcd*/  {"cd",     "candela",   1.0,        { 0, 0, 0, 0, 0, 0, 1}},
/*TUHz*/  {"Hz",     "hetrz",     1.0,        { 0,-1, 0, 0, 0, 0, 0}},
/*TUN*/   {"N",      "newton",    1.0,        { 1, 1,-2, 0, 0, 0, 0}},
/*TUPa*/  {"Pa",     "pascal",    1.0,        {-1, 1,-2, 0, 0, 0, 0}},
/*TUJ*/   {"J",      "joule",     1.0,        { 2, 1,-2, 0, 0, 0, 0}},
/*TUW */  {"W",      "watt",      1.0,        { 2, 1,-3, 0, 0, 0, 0}},
/*TUC*/   {"C",      "coulomb",   1.0,        { 0, 0, 1, 1, 0, 0, 0}},
/*TUV*/   {"V",      "volt",      1.0,        { 2, 1,-3,-1, 0, 0, 0}},
/*TUohm*/ {"\\Omega","ohm",       1.0,        { 2, 1,-3,-2, 0, 0, 0}},
/*TUS*/   {"S",      "siemens",   1.0,        {-2,-1, 3, 2, 0, 0, 0}},
/*TUF*/   {"F",      "farad",     1.0,        {-2,-1, 4, 2, 0, 0, 0}},
/*TUT*/   {"T",      "tesla",     1.0,        { 0, 1,-2,-1, 0, 0, 0}},
/*TUWb*/  {"Wb",     "weber",     1.0,        { 2, 1,-2,-1, 0, 0, 0}},
/*TUH*/   {"H",      "henry",     1.0,        { 2, 1,-2,-2, 0, 0, 0}},
/*TUlm*/  {"lm",     "lumen",     1.0,        { 0, 0, 0, 0, 0, 0, 1}},
/*TUlx*/  {"lx",     "lux",       1.0,        {-2, 0, 0, 0, 0, 0, 1}},
/*TUBq */ {"Bq",     "becquerel", 1.0,        { 0, 0,-1, 0, 0, 0, 0}},
/*TUGy*/  {"Gy",     "gray",      1.0,        { 2, 0,-2, 0, 0, 0, 0}},
/*TUSv*/  {"Sv",     "sievert",   1.0,        { 2, 0,-2, 0, 0, 0, 0}},
/*TUrad*/ {"rad",    "radian",    1.0,        { 0, 0, 0, 0, 0, 0, 0}},
/*TUsr*/  {"sr" ,    "stradian", 1.0,        { 0, 0, 0, 0, 0, 0, 0}},
/*TUnull*/{"" ,      "sans unit",1.0,        { 0, 0, 0, 0, 0, 0, 0}},
/*TUda*/  {"",      "degr",     M_PI/180.0, { 0, 0, 0, 0, 0, 0, 0}},
/*TUma*/  {"'",      "minute",    M_PI/10800, { 0, 0, 0, 0, 0, 0, 0}},
/*TUsa*/  {"''",     "seconde",   M_PI/648000,{ 0, 0, 0, 0, 0, 0, 0}},
/*TUangs*/{"\\o{A}", "angstrm",  1e-10,      { 1, 0, 0, 0, 0, 0, 0}},
/*TUbarn*/{"b",      "barn",      1e-28,      { 2, 0, 0, 0, 0, 0, 0}},
/*TUare*/ {"a",      "are",       1e2,        { 2, 0, 0, 0, 0, 0, 0}},
/*TUl*/   {"L",      "litre",     1e-3,       { 3, 0, 0, 0, 0, 0, 0}},
/*TUt*/   {"t",      "tonne",     1e3,        { 0, 1, 0, 0, 0, 0, 0}},
/*TUbar*/ {"bar",    "bar",       1e5,        {-1, 1,-2, 0, 0, 0, 0}},
/*TUeV*/  {"eV",     "eV",        1.60218e-19,{ 2, 1,-2, 0, 0, 0, 0}},
/*TUuam*/ {"uma",    "uma",       1.66054e-27,{ 0, 1, 0, 0, 0, 0, 0}}
};

 /**
  * preferred SI units list
  * source: Handbook of Chemistry & Physics 78, CRC Press 1997, page 1-20
  * full names of the units are in French, with a Latin-1 encoding
  **/
unite_data pref_units[] ={
/*TUm*/   {"m",      "mtre",   1.0,     { 1, 0, 0, 0, 0, 0, 0}},
/*   */   {"kg",    "kilogramme",1.0,    { 0, 1, 0, 0, 0, 0, 0}},
/*TUs*/   {"s",      "seconde", 1.0,     { 0, 0, 1, 0, 0, 0, 0}},
/*TUA*/   {"A",      "ampre",  1.0,     { 0, 0, 0, 1, 0, 0, 0}},
/*TUK*/   {"K",      "kelvin",  1.0,     { 0, 0, 0, 0, 1, 0, 0}},
/*TUmol*/ {"mol",    "mol",     1.0,     { 0, 0, 0, 0, 0, 1, 0}},
/*TUcd*/  {"cd",     "candela", 1.0,     { 0, 0, 0, 0, 0, 0, 1}},
/*TUHz*/  {"Hz",     "hetrz",   1.0,     { 0,-1, 0, 0, 0, 0, 0}},
/*TUN*/   {"N",      "newton",  1.0,     { 1, 1,-2, 0, 0, 0, 0}},
/*TUPa*/  {"Pa",     "pascal",  1.0,     {-1, 1,-2, 0, 0, 0, 0}},
/*TUJ*/   {"J",      "joule",   1.0,     { 2, 1,-2, 0, 0, 0, 0}},
/*TUW */  {"W",      "watt",    1.0,     { 2, 1,-3, 0, 0, 0, 0}},
/*TUC*/   {"C",      "coulomb", 1.0,     { 0, 0, 1, 1, 0, 0, 0}},
/*TUV*/   {"V",      "volt",    1.0,     { 2, 1,-3,-1, 0, 0, 0}},
/*TUohm*/ {"ohm",    "ohm",     1.0,     { 2, 1,-3,-2, 0, 0, 0}},
/*TUS*/   {"S",      "siemens", 1.0,     {-2,-1, 3, 2, 0, 0, 0}},
/*TUF*/   {"F",      "farad",   1.0,     {-2,-1, 4, 2, 0, 0, 0}},
/*TUT*/   {"T",      "tesla",   1.0,     { 0, 1,-2,-1, 0, 0, 0}},
/*TUWb*/  {"Wb",     "weber",   1.0,     { 2, 1,-2,-1, 0, 0, 0}},
/*TUH*/   {"H",      "henry",   1.0,     { 2, 1,-2,-2, 0, 0, 0}},
/*TUlm*/  {"lm",     "lumen",   1.0,     { 0, 0, 0, 0, 0, 0, 1}},
/*TUlx*/  {"lx",     "lux",     1.0,     {-2, 0, 0, 0, 0, 0, 1}},
};

int significative(char* text);
/**
 * returns the number of significative digits of a decimal number
 * @param text the decimal number as a cstr
 * @return number of significative nubers; leading zeroes are not taken
 * in account. A true zero is a special case.
 **/
int significative(char* text){
  int i,j,result=0;
  char *end = text+strlen(text);
  while (end>text && *(end-1)==' '){ // removes the rightmost spaces
    end--;
    *end=0;
  }
  for(i=0;
      i<strlen(text)&&(text[i]=='0'||text[i]=='.'|| text[i]=='+'||text[i]=='-');
      i++){
    //skip leading plus,minus,zeros and the decimal point
  }
  if (i==strlen(text)){ // the number is probably zero
    result=1;
    char * dot = strchr(text,'.');
    if (dot != NULL && *dot == '.') result += (end-dot)-1;
  } else { // the number is not zero
    for(j=i;j<strlen(text)&&(text[j]>='0'&&text[j]<='9'||text[j]=='.');j++){
      if (text[j]!='.') {
	result++;
      } else {
	//skip the decimal point
      }
    }
  }
  return result;
}


#line 268 "unitesparser.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    EE = 258,
    DECIMAL = 259,
    INT = 260,
    SPC = 261,
    COLON = 262,
    Uh = 263,
    Umin = 264,
    Um = 265,
    Ug = 266,
    Us = 267,
    UA = 268,
    UK = 269,
    Umol = 270,
    Ucd = 271,
    UHz = 272,
    UN = 273,
    UPa = 274,
    UJ = 275,
    UW = 276,
    UC = 277,
    UV = 278,
    Uohm = 279,
    US = 280,
    UF = 281,
    UT = 282,
    UWb = 283,
    UH = 284,
    Ulm = 285,
    Ulx = 286,
    UBq = 287,
    UGy = 288,
    USv = 289,
    Urad = 290,
    Usr = 291,
    PUIS = 292,
    PP = 293,
    POINT = 294,
    BARRE = 295,
    Uda = 296,
    Uma = 297,
    Usa = 298,
    Uangs = 299,
    Ubarn = 300,
    Uare = 301,
    Ul = 302,
    Ut = 303,
    Ubar = 304,
    UeV = 305,
    Uuam = 306,
    Signif = 307,
    PlusminPC = 308
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);



/* Copy the second part of user declarations.  */

#line 370 "unitesparser.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   141

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  16
/* YYNRULES -- Number of rules.  */
#define YYNRULES  73
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  86

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   308

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   260,   260,   261,   264,   274,   275,   286,   289,   290,
     294,   300,   309,   317,   327,   328,   331,   343,   346,   352,
     366,   370,   377,   384,   391,   398,   403,   431,   432,   435,
     436,   437,   438,   442,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EE", "DECIMAL", "INT", "SPC", "COLON",
  "Uh", "Umin", "Um", "Ug", "Us", "UA", "UK", "Umol", "Ucd", "UHz", "UN",
  "UPa", "UJ", "UW", "UC", "UV", "Uohm", "US", "UF", "UT", "UWb", "UH",
  "Ulm", "Ulx", "UBq", "UGy", "USv", "Urad", "Usr", "PUIS", "PP", "POINT",
  "BARRE", "Uda", "Uma", "Usa", "Uangs", "Ubarn", "Uare", "Ul", "Ut",
  "Ubar", "UeV", "Uuam", "Signif", "PlusminPC", "$accept", "but",
  "valeur_mixte", "style", "valeur", "sans_unite", "spc", "unite",
  "suiv_unit", "point", "prim_unit1", "prim_unit", "puissance01",
  "decimal", "prefixe", "base_unite", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308
};
# endif

#define YYPACT_NINF -67

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-67)))

#define YYTABLE_NINF -12

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
       9,     4,     8,    19,   -67,     2,   -67,     0,    16,    17,
     -67,   -67,    46,     9,   -67,   -67,    46,   -67,   -67,    90,
     -67,    90,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,
     -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,    90,   -67,
     -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,
     -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,   -67,
     -67,   -24,   -14,   -67,    90,   -67,   -67,    18,   -35,   -67,
     -67,   -67,   -67,   -67,   -67,   -67,    46,   -67,    46,   -67,
     -67,   -67,   -67,   -67,   -67,   -67
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    30,    29,     0,     2,    14,     3,    14,     0,     0,
       1,    15,     0,     0,    12,    13,     0,    31,    32,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    48,    49,    50,    51,    52,    53,    47,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    33,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
       6,     7,    27,    17,     0,    25,     4,    14,     8,    34,
      36,    47,    23,    21,    22,    20,     0,    16,     0,    28,
      26,    24,     9,    10,    19,    18
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -67,   -67,    12,   -67,   -67,   -67,    21,    11,   -67,   -67,
     -67,   -66,   -67,    15,   -67,   -18
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     3,     4,    60,     5,     6,    16,    61,    77,    78,
      62,    63,    80,     7,    64,    65
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
     -11,    72,    -5,    73,    75,    76,    11,     8,    11,    12,
      84,     9,    85,     1,     2,    75,    76,    82,    83,    10,
      74,    17,    18,    79,    11,    66,    13,    68,    67,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    81,     0,     0,     0,
       0,     0,    14,    15,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,     0,    48,     0,     0,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    69,    20,
      70,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    71,    39,    40,
      41,    42,    43,    44,    45,    46,    47,     0,     0,     0,
       0,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59
};

static const yytype_int8 yycheck[] =
{
       0,    19,     0,    21,    39,    40,     6,     3,     6,     7,
      76,     3,    78,     4,     5,    39,    40,    52,    53,     0,
      38,     5,     5,    37,     6,    13,     5,    16,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    52,    53,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     4,     5,    55,    56,    58,    59,    67,     3,     3,
       0,     6,     7,    60,    52,    53,    60,     5,     5,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    38,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      57,    61,    64,    65,    68,    69,    56,    67,    61,     8,
      10,    27,    69,    69,    69,    39,    40,    62,    63,    37,
      66,    69,    52,    53,    65,    65
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    54,    55,    55,    56,    56,    56,    57,    58,    58,
      58,    59,    59,    59,    60,    60,    61,    61,    62,    62,
      63,    64,    64,    64,    64,    64,    65,    66,    66,    67,
      67,    67,    67,    68,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     3,     1,     3,     1,     3,     4,
       4,     1,     2,     2,     0,     1,     2,     1,     2,     2,
       1,     2,     2,     2,     2,     1,     2,     0,     1,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 260 "unites.y" /* yacc.c:1646  */
    {result = (yyvsp[0]);}
#line 1527 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 261 "unites.y" /* yacc.c:1646  */
    {result = (yyvsp[0]);}
#line 1533 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 264 "unites.y" /* yacc.c:1646  */
    {
  int i;
  for(i=0; i < BU_LAST; i++){
    if ((yyvsp[-2]).base[i] != (yyvsp[0]).base[i]) yyerror ("not homogeneous units");
  }
  if ((yyvsp[-2]).multip <= (yyvsp[0]).maxmultip) yyerror ("incorrect mutiple units ordering");
  (yyval).val=(yyvsp[-2]).val*(yyvsp[-2]).multip+(yyvsp[0]).val*(yyvsp[0]).multip;
  (yyval).multip=1; (yyval).maxmultip = (yyvsp[-2]).multip;
  (yyval).wanted_unit="";
}
#line 1548 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 274 "unites.y" /* yacc.c:1646  */
    {(yyval)=(yyvsp[0]); (yyval).maxmultip=(yyvsp[0]).multip;(yyval).wanted_unit="";}
#line 1554 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 6:
#line 275 "unites.y" /* yacc.c:1646  */
    {
  int i;
  (yyval)=(yyvsp[-2]); (yyval).maxmultip=(yyvsp[-2]).multip;
  for(i=0; i < BU_LAST; i++){
    if ((yyvsp[-2]).base[i] != (yyvsp[0]).base[i]) yyerror ("wanted unit not homogeneous");
  }  
  (yyval).wanted_multip=(yyvsp[0]).multip;
  (yyval).wanted_unit=(yyvsp[0]).s;
}
#line 1568 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 286 "unites.y" /* yacc.c:1646  */
    {(yyval)=(yyvsp[0]);}
#line 1574 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 289 "unites.y" /* yacc.c:1646  */
    {(yyval)=(yyvsp[0]); (yyval).val=val_decimal; (yyval).signif=0; (yyval).pcent=0; (yyval).v=(yyvsp[-2]).v;}
#line 1580 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 290 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[-1]); (yyval).val=val_decimal; 
  (yyval).signif=val_int; (yyval).pcent=0;
}
#line 1589 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 294 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[-1]); (yyval).val=val_decimal; 
  (yyval).pcent=val_int; (yyval).signif=0;
}
#line 1598 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 300 "unites.y" /* yacc.c:1646  */
    {
  int i;
  (yyval)=(yyvsp[0]);
  (yyval).val=val_decimal; 
  for (i=0; i < BU_LAST; i++){(yyval).base[i]=unites[TUnull].base[i];} 
  (yyval).multip=1.0; 
  (yyval).signif=0; (yyval).pcent=0;
  (yyval).wanted_unit="";
}
#line 1612 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 309 "unites.y" /* yacc.c:1646  */
    {
  int i;
  (yyval)=(yyvsp[-1]);
  (yyval).val=val_decimal; 
  for (i=0; i < BU_LAST; i++){(yyval).base[i]=unites[TUnull].base[i];} 
  (yyval).multip=1.0; 
  (yyval).signif=val_int; (yyval).pcent=0;
}
#line 1625 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 317 "unites.y" /* yacc.c:1646  */
    {
  int i;
  (yyval)=(yyvsp[-1]);
  (yyval).val=val_decimal; 
  for (i=0; i < BU_LAST; i++){(yyval).base[i]=unites[TUnull].base[i];} 
  (yyval).multip=1.0; 
  (yyval).signif=0; (yyval).pcent=val_int;
}
#line 1638 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 331 "unites.y" /* yacc.c:1646  */
    {
  int index;
  (yyval).unite = TU_LAST; /* unknown unit (not given) */
  strncpy(buffer,(yyvsp[-1]).s,MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-strlen((yyvsp[-1]).s)); 
  free((yyvsp[-1]).s); free((yyvsp[0]).s);
  (yyval).s=strdup(buffer);
  for(index=0; index< BU_LAST; index++){
    (yyval).base[index] = (yyvsp[-1]).base[index]+(yyvsp[0]).base[index] ; 
  }
  (yyval).multip = (yyvsp[-1]).multip*(yyvsp[0]).multip;
}
#line 1655 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 343 "unites.y" /* yacc.c:1646  */
    { (yyval)=(yyvsp[0]); }
#line 1661 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 346 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]); strncpy(buffer,".",MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-1); 
  free((yyvsp[0]).s);
  (yyval).s=strdup(buffer);
}
#line 1672 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 352 "unites.y" /* yacc.c:1646  */
    {
  int index;
  (yyval)=(yyvsp[0]); 
  (yyval).multip = 1/ (yyval).multip;
  strncpy(buffer,"/",MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-1); 
  free((yyvsp[0]).s);
  (yyval).s=strdup(buffer);
  for(index=0; index< BU_LAST; index++){
    (yyval).base[index] *= -1; 
  }
}
#line 1689 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 370 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]);
  strncpy(buffer,"m",MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-1); 
  free((yyvsp[0]).s);
  (yyval).s = strdup(buffer); (yyval).multip*=1e-3; 
}
#line 1701 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 377 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]);
  strncpy(buffer,"T",MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-1); 
  free((yyvsp[0]).s);
  (yyval).s = strdup(buffer); (yyval).multip*=1e12;
}
#line 1713 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 384 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]);
  strncpy(buffer,"h",MAXBUF); 
  strncat(buffer,(yyvsp[0]).s,MAXBUF-1); 
  free((yyvsp[0]).s);
  (yyval).s = strdup(buffer); (yyval).multip*=1e2;
}
#line 1725 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 391 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]);
  strncpy(buffer, (yyvsp[-1]).s,MAXBUF); 
  strncat(buffer, (yyvsp[0]).s, MAXBUF-strlen((yyvsp[-1]).s));
  free((yyvsp[-1]).s); free((yyvsp[0]).s);(yyval).s=strdup(buffer); 
  (yyval).multip*=(yyvsp[-1]).multip;
  }
#line 1737 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 398 "unites.y" /* yacc.c:1646  */
    {
  (yyval)=(yyvsp[0]);
}
#line 1745 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 403 "unites.y" /* yacc.c:1646  */
    {
  int index;
  mpreal r;

  (yyval).i=(yyvsp[0]).i;
  strncpy(buffer, (yyvsp[-1]).s,MAXBUF);
  if ((yyvsp[0]).i!=1){
    strncat(buffer, "^%d",MAXBUF-strlen((yyvsp[-1]).s)); 
    sprintf(buffer2, buffer, (yyvsp[0]).i);
  }
  else strncpy(buffer2,buffer,MAXBUF);
  (yyval).s=strdup(buffer2); free((yyvsp[-1]).s);
  for(index=0; index< BU_LAST; index++){
    (yyval).base[index] = unites[(yyvsp[-1]).unite].base[index]*(yyvsp[0]).i;
  }
  if ((yyvsp[0]).i>0){
    for(index=0, r=1; index<(yyvsp[0]).i ; index++){
      r*= (yyval).multip;
    }
  } else {
    for(index=0, r=1; index>(yyvsp[0]).i ; index--){
      r /= (yyval).multip;
    }
  }
  (yyval).multip=r;
}
#line 1776 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 431 "unites.y" /* yacc.c:1646  */
    {(yyval).i=1;}
#line 1782 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 432 "unites.y" /* yacc.c:1646  */
    {(yyval).i = val_int;}
#line 1788 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 435 "unites.y" /* yacc.c:1646  */
    {(yyval).val=val_decimal;}
#line 1794 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 436 "unites.y" /* yacc.c:1646  */
    {(yyval).val=val_decimal;}
#line 1800 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 437 "unites.y" /* yacc.c:1646  */
    {val_decimal=(yyvsp[-2]).v; int e = atoi((yyvsp[0]).v); if (e>0) for (int i=0; i<e;i++) val_decimal *=10; if (e<0) for (int i=0; i<-e;i++) val_decimal /=10; (yyval).val=val_decimal;}
#line 1806 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 438 "unites.y" /* yacc.c:1646  */
    {val_decimal=atoi((yyvsp[-2]).v); int e = atoi((yyvsp[0]).v); if (e>0) for (int i=0; i<e;i++) val_decimal *=10; if (e<0) for (int i=0; i<-e;i++) val_decimal /=10; (yyval).val=val_decimal;}
#line 1812 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 442 "unites.y" /* yacc.c:1646  */
    {(yyval).multip=1.0; char c=(yyval).s[0]; 
 switch (c){
 case 'y' : (yyval).multip = 1e-24; break;
 case 'z' : (yyval).multip = 1e-21; break;
 case 'a' : (yyval).multip = 1e-18; break;
 case 'f' : (yyval).multip = 1e-15; break;
 case 'p' : (yyval).multip = 1e-12; break;
 case 'n' : (yyval).multip = 1e-9; break;
 case '' : (yyval).multip = 1e-6; break;
 case 'c' : (yyval).multip = 1e-2; break;
 case 'd' : if (!strcmp ((yyval).s,"da") ) (yyval).multip = 10.0;
    else (yyval).multip = 0.1; break;
 case 'h' : (yyval).multip = 1e2; break;
 case 'k' : (yyval).multip = 1e3; break;
 case 'M' : (yyval).multip = 1e6; break;
 case 'G' : (yyval).multip = 1e9; break;
 case 'P' : (yyval).multip = 1e15; break;
 case 'E' : (yyval).multip = 1e18; break;
 case 'Z' : (yyval).multip = 1e21; break;
 case 'Y': (yyval).multip = 1e24; break;
 }
}
#line 1839 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 467 "unites.y" /* yacc.c:1646  */
    {(yyval).unite=TUh; (yyval).s = strdup("h"); (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1845 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 468 "unites.y" /* yacc.c:1646  */
    {(yyval).unite=TUmin;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1851 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 469 "unites.y" /* yacc.c:1646  */
    {(yyval).unite=TUm; (yyval).s = strdup("m"); (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1857 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 470 "unites.y" /* yacc.c:1646  */
    {(yyval).unite=TUg;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1863 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 471 "unites.y" /* yacc.c:1646  */
    {(yyval).unite=TUs;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1869 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 472 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUA;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1875 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 473 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUK;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1881 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 474 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUmol;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1887 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 475 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUcd;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1893 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 476 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUHz;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1899 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 477 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUN;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1905 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 478 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUPa;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1911 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 479 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUJ;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1917 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 480 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUT; (yyval).s = strdup("T"); (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1923 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 481 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUW;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1929 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 482 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUC;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1935 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 483 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUV;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1941 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 484 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUohm;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1947 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 485 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUS;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1953 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 486 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUF;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1959 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 487 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUWb;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1965 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 488 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUH;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1971 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 489 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUlm;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1977 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 490 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUlx;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1983 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 491 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUBq;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1989 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 492 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUGy;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 1995 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 493 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUSv;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2001 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 494 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUrad;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2007 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 495 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUsr;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2013 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 496 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUda;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2019 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 497 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUma;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2025 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 498 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUsa;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2031 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 499 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUangs;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2037 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 500 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUbarn;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2043 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 501 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUare;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2049 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 502 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUl;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2055 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 503 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUt;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2061 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 504 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUbar;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2067 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 505 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUeV;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2073 "unitesparser.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 506 "unites.y" /* yacc.c:1646  */
    { (yyval).unite = TUuam;  (yyval).multip=unites[(yyval).unite].multiplicateur;}
#line 2079 "unitesparser.cc" /* yacc.c:1646  */
    break;


#line 2083 "unitesparser.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 511 "unites.y" /* yacc.c:1906  */


#include "uniteslex.cc"
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#ifdef RECODE_SUPPORT
  #include <recode.h>
#endif

#include <regex.h>

const char *program_name;
int isUTF8;

/* the program is below */

typedef enum {option_default, option_s, option_o, option_l} optiontype;

yyFlexLexer lexer;
yyFlexLexer * thelexer = &lexer;

int yylex(){
  return thelexer->yylex();
}


/**
 * this function is called when an error is detected. It will print a usable
 * hint about the detected error.
 * @param msg the error message.
 **/
inline int yyerror(const char * msg){
  printf("ERROR at %ld : %s\n", pos, msg);
  exit(1);
}

/**
 * this function can be used to debug new features. It outputs verbose
 * data describing the parsed expression. Messages are in French, with
 * Latin-1 encoding.
 **/
void test_verbeux(){
  int i;
  yyparse();
  if (result.s) {
    if (result.unite == TU_LAST){
      cout << result.s << " " << result.multip*result.val << " SI (quation aux dimensions : ";
      for (i=0; i<BU_LAST; i++){
	printf("%3d", result.base[i]);
      }
      printf(")\n");
    }
    else {
      if (result.i!=1) 
	cout <<  result.s << " (" << result.multip*result.val 
		  << " " << unites[result.unite].nom << ")^{" << result.i 
		  << "}\n";
      else 
	cout << result.s << " " << result.multip*result.val 
		  << " " << unites[result.unite].nom << "\n";
    }
  }
  else fprintf(stderr, "problme : result.s = null\n");
}

/**
 * this function is used to output a normalized string describing the
 * parsed data.
 **
 * here is the format of the output:
 * double int int int int int int int
 * which mean respectively ...
 **
 * value
 * power of the length unit (m)
 * power of the mass unit (kg)
 * power of the time unit (s)
 * power of the current unit (A)
 * power of the temperature unit (K)
 * power of the matter quantity unit (mol)
 * power of the light intensity (cd)
 * number of significative numbers
 * tolerance (as a percentage)
 **/
void sortie_normalisee(){
  int i,s=0,pc=0;

  yyparse();
  // the result will be displaied as a decimal number rather as a fraction
  cout << result.multip*result.val;
  if (count_signif){ // take significative numbers in account
    if (!result.signif) {
      s=significative(result.v);
    } else {
      s=result.signif;
    }
  }
  pc=result.pcent;
  for (i=0; i<BU_LAST; i++){
    printf(" %3d", result.base[i]);
  }
  printf("    %d    %d\n",s,pc);
}

/**
 * displays the unit and eventually the tolerance string
 * @param option may be "option_l" to enforce LaTeX encoding
 * @param unit the name of the unit
 * @param tolerance a percentage of tolerance. If it is non-zero, an
 * additional mention will be displayed to express a tolerance.
 **/
void printUnit(optiontype option, string unit, int tolerance){
  char * indexohm;
  char buffer[128];
  char *codedunit;

#ifdef RECODE_SUPPORT
  if(isUTF8) {
    RECODE_OUTER outer = recode_new_outer (true);
    RECODE_REQUEST request = recode_new_request (outer);
    recode_scan_request (request, "latin1..utf8"); 
    codedunit=strdup(recode_string(request,unit.c_str()));
  } else {
    codedunit=strdup(unit.c_str());
  }
#else
  codedunit=strdup(unit.c_str());
#endif

  if (option==option_l){
    strncpy(buffer, codedunit,sizeof(buffer));
    indexohm=strstr(buffer,"ohm");
    if (indexohm){
      strncpy(indexohm, "\\Omega", sizeof(buffer)-strlen("\\Omega")+strlen("ohm"));
    }
    printf(" %s",buffer);
  } else {
    printf(" %s",codedunit);
  }
  if (tolerance){
    if (option==option_l){
      printf(" \\pm %d\\,\\%%",tolerance);
    } else{
      printf(" +-%d%%",tolerance);
    }
  }
  printf("\n");
  free(codedunit);
}

mpreal my_rounded(mpreal r);
/**
 * Uses the rounding method which are taught to students: if the
 * decimal value is 0.5 or more, rounds away from zero; else
 * rounds towards zero
 * @param r the value to round
 * @return the rounded value
 **/
mpreal my_rounded(mpreal r){
  // multiply r by 10, convert it to a string,
  // round the value (converted to mpreal), then convert to a string
  string rTimes10s = (round(mpreal((10*r).toString()))).toString();
  // remove the last digit
  string rs = rTimes10s.substr(0,rTimes10s.size()-1);
  if (*rTimes10s.rbegin() >= '5') { // first number of the mantissa is 5 or more
    return 1+ mpreal(rs);
  } else {
    return mpreal(rs);
  }
}

mpreal my_rounded_signif(mpreal r, int s);
/**
 * rounds a number to keep "s" significant numbers.
 * if s == the number of digits before the decimal dot, this function
 * returns the same value as my_rounded(r)
 * @param r the value to round
 * @param s the number of significant digits
 * @return the rounded value
 **/
mpreal my_rounded_signif(mpreal r, int s){
  mpreal absval=abs(r);
  mpreal powten=1;
  // adjust powten so that powten*absval == abs(r) and 10 > absval >=1.
  while(absval >=10){powten*=10; absval/=10;}
  while(absval < 1) {powten/=10; absval*=10;}
  // then divides powten by 10**s
  for (int i=1;i<s;i++) powten/=10;
  return my_rounded(r/powten)*powten;
}

mpreal my_rounded_signif1(mpreal r, int s);
/**
 * This is an attempt to use directly the rounding methods of MPFR library;
 **
 * rounds a number to keep "s" significant numbers.
 * if s == the number of digits before the decimal dot, this function
 * returns the same value as my_rounded(r)
 * @param r the value to round
 * @param s the number of significant digits
 * @return the rounded value
 **/
mpreal my_rounded_signif1(mpreal r, int s){
  // Setup default precision for all subsequent computations
  // MPFR accepts precision in bits - so we do the conversion
  mpreal::set_default_prec(mpfr::digits2bits(s));
  // Setup rounding method as "round to nearest"
  mpreal::set_default_rnd(MPFR_RNDN);
  mpreal result=r;
  return result;
}

/**
 * displays a value
 * @param option may be "option_l" to enforce LaTeX encoding
 * @param result the value issued by the parser
 * @param s a number to shift the decimal point. s>0 shifts the decimal
 * point to the right; s <0 shifts the decimal point to the left.
 **/
void printValue(optiontype option, yystype result, int s){
  char val[128],exp[128], *i, *j, *indexE;
  char buf[128];
  regex_t regex;
  regmatch_t matches[3];
  int success,l;
  int vallen;

  mpreal value=result.multip*result.val;
  if (value==0){
    printf("0");
    if (s>1){
      printf(".");
      for (int i=1; i<s; i++){
	printf("0");
      }
    }
    return;
  }
  value=my_rounded_signif(value, s);
  if (s<=1){
    snprintf(buf,sizeof(buf),"%1.0e", value.toDouble() );
  } else {
    snprintf(buf,sizeof(buf),"%1.*e", s-1,value.toDouble() );
  }
  // simplifications
  regcomp(&regex, "^(.*)(e[+-][0-9]+)$", REG_EXTENDED);
  regexec(&regex, buf, 3, matches,0);
  if (strcmp(buf+matches[2].rm_so,"e+00")==0) {
    // removing e+00
    *(buf+matches[2].rm_so)=0;
  }
  l=strlen(buf);
  if (*(buf+matches[2].rm_so+1)=='+'){
    j=buf+matches[2].rm_so+2;
    while (*j=='0') j++;
    for(i=buf+matches[2].rm_so+1; j<=buf+l; i++,j++){
      // erasing +0* after e
      *i=*j;
    }
  }
  if (*(buf+matches[2].rm_so+1)=='-'){
    j=buf+matches[2].rm_so+2;
    while (*j=='0') j++;
    for(i=buf+matches[2].rm_so+2; j<=buf+l; i++,j++){
      // erasing 0* after e-
      *i=*j;
    }
  }
  if (option==option_l){
    indexE=strstr(buf,"e");
    if (indexE){
      vallen=indexE-buf;
      strncpy(val,buf,vallen);
      val[vallen]=0;
      strncpy(exp,indexE+1,sizeof(exp));
      printf("%s\\cdot 10^{%s}\\,",val,exp);
    } else{
      printf("%s\\,",buf);
    }
  } else {
    printf("%s",buf);
  }
}

/**
 * parses the input and displays parsed data as a text
 * @param option may be "option_l" to enforce LaTeX enconding
 **
 * the output is formated as follows: <value unit>
 * where value is a number expressing the desired value, taking in account
 * the desired significant digits, and unit is a SI unit or some custom unit,
 * optionnally followed by "+- pcent %", pcent being the tolerance.
 **/
void sortie_texte(optiontype option){
  int i,j,
    s=0, pc=0,
    notfirst=0,
    trouve=0,
    nb_pref=sizeof(pref_units)/sizeof(pref_units[0]);
  int puisdix;

  yyparse();
  if (!result.signif) {
    // the number of significant digits must be computed from the given value
    s=significative(result.v);
  } else {
    // the number of significant digits has been declared
    s=result.signif;
  }
  pc=result.pcent;
  // rounds the value taking in account the number of significant digits
  if (result.wanted_unit.length()>0){
    result.multip /= result.wanted_multip;
  }else{ // set the multiplier to 1 if the input unit has been declared
    if (result.s && strlen(result.s)>0){
      result.multip = 1;
    }
  }
  // print the value
  printValue(option, result, s);
  // if a custom unit is wanted, use it
  if (result.wanted_unit.length()>0){
    printUnit(option, result.wanted_unit, pc);
    return;
  }
  // else print the given unit if it is declared
  if (result.s && strlen(result.s)>0){
    printUnit(option, result.s, pc);
    return;
  }
  // else search a preferred unit
  for (i=0; i<nb_pref; i++){
    trouve=(result.base[0]==pref_units[i].base[0]);
    for (j=1; j<BU_LAST; j++){
      trouve &= (result.base[j]==pref_units[i].base[j]);
    }
    if (trouve){
      printUnit(option, pref_units[i].sym, pc);
      return;
    }
  }
  // test whether there will be a visible unit
  int visible_unit=0;
  for (i=0; i<BU_LAST; i++){
    if (result.base[i]!=0) visible_unit=1;
  }
  if (result.wanted_unit.length()>0) visible_unit=1;
  if(visible_unit!=0){ // display a unit only if it has some sense!
    for (i=0; i<BU_LAST; i++){
      if (result.base[i]!=0){
	if (notfirst) printf("."); else printf(" ");
	printf("%s",unit_names[i]);
	notfirst=1;
	if (result.base[i]!=1){
	  if (option==option_l){
	    printf("^{%d}",result.base[i]);
	  } else {
	    printf("^%d",result.base[i]);
	  }
	}
      }
    }
    printUnit(option, "", pc);
  }
}

/**
 * main function
 * @param argc the number of arguments of the program's call
 * @param argv the vector of arguments
 * @return the exit code of the program
 **/
int main(int argc, char * argv[]){
  const char * optstr = "osl";
  char * envoption=getenv("units_option");
  // environmental option take precedence on command-line options

  optiontype option=option_default;
  
  int ch;
  while (-1 != (ch=getopt(argc,argv,optstr))){
    switch(ch){
    case 's': 
      option=option_s;
      break;
    case 'o':
      option=option_o;
      break;
    case 'l':
      option=option_l;
      break;
    default: 
      break;
    }
  }
  // environmental option take precedence on command-line options
  if (envoption && strncmp(envoption, "s", 2)==0) option=option_s;
  if (envoption && strncmp(envoption, "o", 2)==0) option=option_o;
  if (envoption && strncmp(envoption, "l", 2)==0) option=option_l;
#ifdef RECODE_SUPPORT
  // check whether we are in a UTF8 environment
  char *lc_all=getenv("LC_ALL");
  isUTF8 = (lc_all!= NULL && strstr(lc_all,"UTF-8"));
#endif
  program_name = argv[0];


switch(option){
  case option_s: 
    count_signif=1;
    sortie_normalisee();
    return 0;
    break;
  case option_o:
  case option_l:
    sortie_texte(option);
    return 0;
    break;
  default: 
    break;
  }
  // disabled; use only for debug purpose
  /*test_verbeux();*/
  sortie_normalisee();
  return 0;
}
